summaryrefslogtreecommitdiffstats
path: root/testing/source/mesa/mesa.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'testing/source/mesa/mesa.SlackBuild')
-rwxr-xr-xtesting/source/mesa/mesa.SlackBuild175
1 files changed, 175 insertions, 0 deletions
diff --git a/testing/source/mesa/mesa.SlackBuild b/testing/source/mesa/mesa.SlackBuild
new file mode 100755
index 000000000..7d612e797
--- /dev/null
+++ b/testing/source/mesa/mesa.SlackBuild
@@ -0,0 +1,175 @@
+#!/bin/sh
+
+# Copyright 2006, 2007, 2008, 2009, 2010, 2011 Patrick J. Volkerding, Sebeka, MN, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PKGNAM=mesa
+VERSION=7.10.2
+DEMOVERS=8.0.1
+BUILD=${BUILD:-1}
+
+NUMJOBS=${NUMJOBS:--j8}
+
+# Be sure this list is up-to-date:
+DRI_DRIVERS="i810,i915,i965,mach64,mga,nouveau,r128,r200,r300,r600,radeon,savage,sis,tdfx,unichrome,swrast"
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) export ARCH=i486 ;;
+ arm*) export ARCH=arm ;;
+ *) export ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp}
+PKG=$TMP/package-mesa
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+rm -rf $PKG
+mkdir -p $TMP $PKG
+cd $TMP
+rm -rf Mesa-${VERSION}
+
+tar xvf $CWD/MesaLib-${VERSION}.tar.?z* || exit 1
+# If MesaLib came from git, we might already have GLUT.
+if [ ! -d Mesa-${VERSION}/src/glut/glx ]; then
+ tar xvf $CWD/MesaGLUT-${VERSION}.tar.?z* || exit 1
+fi
+
+cd Mesa-$VERSION
+
+# Make sure ownerships and permissions are sane:
+chown -R root:root .
+find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
+
+# Apply patches from git (and maybe elsewhere):
+# Patches obtained by:
+# git checkout origin/7.9
+# git format-patch 67aeab0b77fb6be864088e69ea74a010b6543fa1..
+if /bin/ls $CWD/patches/*.patch 1> /dev/null 2> /dev/null ; then
+ for patch in $CWD/patches/*.patch ; do
+ patch -p1 < $patch || exit 1 ;
+ done
+fi
+
+# Revert "i915: Enable ARB_fragment_shader by default."
+# https://bugzilla.redhat.com/show_bug.cgi?id=643399
+zcat $CWD/patches/i915_fragment_shader_disable.patch.gz | patch -p1 || exit 1
+
+## Allow Mesa 7.9.x to build against libdrm-2.4.23:
+#zcat $CWD/patches/mesa-7.9-libdrm-2.4.23-nouveau-api.patch.gz | patch -p1 || exit 1
+
+if [ ! -r configure ]; then
+ autoreconf || exit 1
+fi
+
+CFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --sysconfdir=/etc \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --mandir=/usr/man \
+ --docdir=/usr/doc/mesa-$VERSION \
+ --with-dri-driverdir=/usr/lib${LIBDIRSUFFIX}/xorg/modules/dri \
+ --with-dri-drivers="$DRI_DRIVERS" \
+ --enable-xcb \
+ --enable-gallium-nouveau \
+ --build=$ARCH-slackware-linux
+
+# --enable-gallium-llvm \
+# --enable-gallium-swrast \
+# --disable-gallium-svga \
+# --disable-gallium-i915 \
+# --disable-gallium-i965 \
+# --disable-gallium-radeon \
+# --disable-gallium-r600 \
+
+make $NUMJOBS || make || exit 1
+make install DESTDIR=$PKG || exit 1
+
+# Now install the demos
+( cd $TMP
+ rm -rf mesa-demos-$DEMOVERS
+ tar xvf $CWD/mesa-demos-$DEMOVERS.tar.?z* || exit 1
+ cd mesa-demos-$DEMOVERS
+ chown -R root:root .
+ find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
+ CFLAGS="$SLKCFLAGS" \
+ ./configure \
+ --prefix=/usr \
+ --build=$ARCH-slackware-linux
+ # Build and install gears and glinfo, as well as a few other demos
+ make -C src/demos gears glinfo
+ make -C src/xdemos \
+ glthreads glxcontexts glxdemo glxgears glxgears_fbconfig \
+ glxheads glxinfo glxpbdemo glxpixmap
+ mkdir -p $PKG/usr/bin
+ cp -a src/demos/{gears,glinfo} $PKG/usr/bin
+ for i in glthreads glxcontexts glxdemo glxgears glxgears_fbconfig \
+ glxheads glxinfo glxpbdemo glxpixmap ; do
+ cp -a src/xdemos/$i $PKG/usr/bin ;
+ done
+)
+
+# Strip binaries:
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+# Compress info files, if any:
+if [ -d $PKG/usr/info ]; then
+ rm -f $PKG/usr/info/dir
+ gzip -9 $PKG/usr/info/*
+fi
+
+mkdir -p $PKG/usr/doc/Mesa-$VERSION/html
+cp -a \
+ docs/COPYING* docs/relnotes-${VERSION}*.html docs/README* docs/GL* \
+ $PKG/usr/doc/Mesa-$VERSION
+cp -a docs/*.html $PKG/usr/doc/Mesa-$VERSION/html
+rm -f $PKG/usr/doc/Mesa-$VERSION/html/relnotes*.html
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $TMP/${PKGNAM}-$VERSION-$ARCH-$BUILD.txz
+